# -*- coding: utf-8 -*-
#32sn2-1.rb

#トップレベルに、1回の勝負を記述するメソッドを定義
#until文の中身が簡潔になった

#クラス定義は変更なし
	class Fighter

	def name
		@name
	end

	def name= name
		@name=name
	end


	def attack
		@attack
	end

	def attack= attack
		@attack=attack
	end


	def hp
		@hp
	end

	def hp= hp
		@hp=hp
	end


	def win
		@win
	end

	def win= win
		@win=win
	end


	def lose
		@hp -= 1
		@attack *= 1.25
		@lose
	end

	def lose= lose
		@lose=lose
	end


	def draw
		@draw
	end

	def draw= draw
		@draw=draw
	end


	def report
		print @name
		print ":攻撃力"
		print @attack
		print " HP"
		puts @hp
	end

end

#トップレベルの処理


#本では修正したその場所に書いてあるが
#サンプルではキレイな場所に移した
#1回の勝負をまとめたメソッド
def fight_single h,e

	result=h.attack-e.attack

	if result>0 then
		puts h.win
		puts e.lose
	elsif result<0 then
		puts h.lose
		puts e.win
	else
		puts h.draw
		puts e.draw
	end

end



#インスタンスの作成も変更なし

hiroshi=Fighter.new
hiroshi.name="ひろし"
hiroshi.attack=8
hiroshi.hp=3 #@hpを設定
hiroshi.win="オラァー"
hiroshi.lose="グハッ"
hiroshi.draw="チッ"

e1=Fighter.new
e1.name="E-1"
e1.attack=6
e1.hp=5 #@hpを設定
e1.win="ギャギャギャ"
e1.lose="ピギーッ"
e1.draw="ゲ？"


#訓練開始
puts "************************"
puts "訓練開始"
puts "#{hiroshi.name}対#{e1.name}"
puts "************************"
puts


#until文の中でfight_singleを呼び出す

until hiroshi.hp==0 || e1.hp==0 do

	#33sn2-2.rbではコレを見落としたんだヨ
	hiroshi.report
	e1.report
	puts

	fight_single hiroshi,e1

	puts #次の繰り返しのために見やすくする
end


