# -*- coding: utf-8 -*-

#32sn2-1.rb
#Fighterクラスに@hpを定義
#負けると@hp, @attackを変更

class Fighter

	def name
		@name
	end

	def name= name
		@name=name
	end
	

	def attack
		@attack
	end

	def attack= attack
		@attack=attack
	end


	#インスタンス変数@hpを追加
	def hp
		@hp
	end

	def hp= hp
		@hp=hp
	end
	

	def win
		@win
	end
	
	def win= win
		@win=win
	end


	#lose メソッドを変更
	#他の処理をしてから
	#@loseを戻す
	def lose
		@hp -= 1
		@attack *= 1.25
		@lose
	end

	def lose= lose
		@lose=lose
	end
	

	def draw
		@draw
	end

	def draw= draw
		@draw=draw
	end

	#攻撃力とHPを報告
	def report
		print @name
		print ":攻撃力"
		print @attack
		print " HP"
		puts @hp
	end

end	#クラス定義の終了


#トップレベルの処理

#hiroshiインスタンスの作成と設定
hiroshi=Fighter.new
hiroshi.name="ひろし"
hiroshi.attack=8
hiroshi.hp=3 #@hpを設定
hiroshi.win="オラァー"
hiroshi.lose="グハッ"
hiroshi.draw="チッ"

#e1インスタンスの作成と設定
e1=Fighter.new
e1.name="E-1"
e1.attack=6
e1.hp=5 #@hpを設定
e1.win="ギャギャギャ"
e1.lose="ピギーッ"
e1.draw="ゲ？"


#訓練開始
puts "************************"
puts "訓練開始"
puts "#{hiroshi.name}対#{e1.name}"
puts "************************"
puts

#攻撃力とHPを報告
hiroshi.report
e1.report

puts

#勝敗の判定
result=hiroshi.attack-e1.attack

if result>0 then
	puts hiroshi.win
	puts e1.lose
elsif result<0 then
	puts hiroshi.lose
	puts e1.win
else
	puts hiroshi.draw
	puts e1.draw
end

puts

#負けたほうの攻撃力とHPは変更されているか？
hiroshi.report
e1.report
