# -*- coding: utf-8 -*-

#33sn2-2.rb
#32sn2-1の戦闘を、どちらかのHPがゼロになるまで繰り返す。
#確かに動くが、reportメソッドの呼び出しを
#繰り返し処理に加えるのを忘れたんで、
#壮絶な表示となった。

#クラスの定義は32sn2-1.rbから変更なし

class Fighter

	def name
		@name
	end

	def name= name
		@name=name
	end


	def attack
		@attack
	end

	def attack= attack
		@attack=attack
	end


	def hp
		@hp
	end

	def hp= hp
		@hp=hp
	end


	def win
		@win
	end

	def win= win
		@win=win
	end


	def lose
		@hp -= 1
		@attack *= 1.25
		@lose
	end

	def lose= lose
		@lose=lose
	end
	

	def draw
		@draw
	end

	def draw= draw
		@draw=draw
	end


	def report
		print @name
		print ":攻撃力"
		print @attack
		print " HP"
		puts @hp
	end

end	#クラス定義の終わり


#トップレベルの処理

#インスタンスの作成と設定も変更なし
hiroshi=Fighter.new
hiroshi.name="ひろし"
hiroshi.attack=8
hiroshi.hp=3 #@hpを設定
hiroshi.win="オラァー"
hiroshi.lose="グハッ"
hiroshi.draw="チッ"

e1=Fighter.new
e1.name="E-1"
e1.attack=6
e1.hp=5 #@hpを設定
e1.win="ギャギャギャ"
e1.lose="ピギーッ"
e1.draw="ゲ？"


#訓練開始
puts "************************"
puts "訓練開始"
puts "#{hiroshi.name}対#{e1.name}"
puts "************************"
puts

hiroshi.report
e1.report
puts


#attackメソッドによる攻撃力の差を求め、
#それらの比較をする処理を繰り返す

until hiroshi.hp==0 || e1.hp==0 do

	result=hiroshi.attack-e1.attack
	
	if result>0 then
		puts hiroshi.win
		puts e1.lose
	elsif result<0 then
		puts hiroshi.lose
		puts e1.win
	else
		puts hiroshi.draw
		puts e1.draw
	end
	
end	#untilの終わり


#1回勝負のあと両者の攻撃力とHPを
#表示させる32sn2-1.rbの追加記述が残っていた

puts
hiroshi.report
e1.report
