# -*- coding: utf-8 -*-

#35sn2-4.rb
#最終的な勝者を表示するため
#繰り返し処理を修正

#大勝利か大敗北かのメッセージを
#インスタンス変数を追加
class Fighter

	def name
		@name
	end

	def name= name
		@name=name
	end


	def attack
		@attack
	end

	def attack= attack
		@attack=attack
	end


	def hp
		@hp
	end

	def hp= hp
		@hp=hp
	end


	def win
		@win
	end

	def win= win
		@win=win
	end


	def lose
		@hp -= 1
		@attack *= 1.25
		@lose
	end

	def lose= lose
		@lose=lose
	end


	def draw
		@draw
	end

	def draw= draw
		@draw=draw
	end


	#インスタンス変数を二つ追加

	#完全勝利宣言
	def victory
		@victory
	end

	def victory= victory
		@victory=victory
	end

	#完全敗北宣言
	def doomed
		@doomed
	end

	def doomed= doomed
		@doomed=doomed
	end


	#これだけポツンと残ったが
	#変更なしなのでご心配なく
	def report
		print @name
		print ":攻撃力"
		print @attack
		print " HP"
		puts @hp
	end

end

#トップレベルの処理


def fight_single h,e
	result=h.attack-e.attack
	if result>0 then
		puts h.win
		puts e.lose
	elsif result<0 then
		puts h.lose
		puts e.win
	else
		puts h.draw
		puts e.draw
	end
end


#両インスタンスに
#victoryとdoomedの設定を追加

hiroshi=Fighter.new
hiroshi.name="ひろし"
hiroshi.attack=8
hiroshi.hp=3
hiroshi.win="オラァー"
hiroshi.lose="グハッ"
hiroshi.draw= "チッ"
hiroshi.victory="どんなもんだい"
hiroshi.doomed="空の青木々の緑"

e1=Fighter.new
e1.name="E-1"
e1.attack=6
e1.hp=5
e1.win="ギャギャギャ"
e1.lose="ピギーッ"
e1.draw="ゲ？"
e1.victory="ゲバガガガガ"
e1.doomed="....."


#訓練開始
puts "************************"
puts "訓練開始"
puts "#{hiroshi.name}対#{e1.name}"
puts "************************"
puts


#敵のHPがゼロになるまで繰り返す
until e1.hp==0 do

	hiroshi.report
	e1.report

	#見やすくする
	sleep 1
	puts

	fight_single(hiroshi,e1)

	#繰り返しの途中で
	#ひろしのHPがゼロになったら強制終了
	if hiroshi.hp==0 then
		sleep 3 #最終結果なので3秒引っ張る
		puts #見やすくする
		
		puts hiroshi.doomed
		puts e1.victory
		
		exit	#35sn2-4.rbを終了
	end

	#次の繰り返しに向けて見やすくする
	puts
	sleep 2

end



#無事に繰り返しを終えたらひろし大勝利
sleep 3
puts hiroshi.victory
puts e1.doomed
